1  'FDCIII/BAS: WESTERN DIGITAL 1793 FLOPPY DISK CONTROLLER
2  'TESTER by Dave Owen, c/o CCS, POB 3032, Camarillo, CA,
3  '93011. From "Micro Info Exchange" (Cabrillo Computer
4  'Society Newsletter), August '83, page 5.
5  'If drive 0 on a Model III/4 does not boot, run this test,
6  'It checks the FDC chip--not the disk drives (except to
7  'learn if they are present and active).
8  'If the FDC passes this test, then run Floppy Doctor,
9  'which will extensively exercise the drives themselves
10 CLS:PRINT"TEST 1:  Disk Controller Ready Check...Verify Status Bit 7 set":PRINT
20 OUT 240,208
30 GOSUB 620  
40 IF ST=255 THEN PRINT"No power applied to disk controller chip!"
50 GOSUB 830  
60 PRINT"TEST 2:  Disk Status Checks...Verify Status Bit 2 set":PRINT
70 PRINT"    ...DRIVE 0: ":B=129:GOSUB 940  
80 PRINT"    ...DRIVE 1: ":B=130:GOSUB 940  
90 PRINT"    ...DRIVE 2: ":B=132:GOSUB 940  
100 PRINT"    ...DRIVE 3: ":B=136:GOSUB 940  
110 GOSUB 830  
120 CLS:PRINT"TEST 3:  NMI Register Checks...Verify no errors":PRINT
130 IR=INP(228):PRINT"    ...CONTROLLER:   ";
140 IF IR=62 THEN PRINT"No interrupt--not ready":GOTO 190  
150 IF IR=126 THEN PRINT"No interrupt--ready":GOTO 190  
160 IF IR=190 THEN PRINT"Interrupt requested--not ready":GOTO 190  
170 IF IR=254 THEN PRINT"Interrupt requested--ready":GOTO 190  
180 PRINT TAB(10)"ERROR--interrupt failure"
190 PRINT"    ...DISK DRIVE 0: ";:OUT 244,129:GOSUB 880  
200 PRINT"    ...DISK DRIVE 1: ";:OUT 244,130:GOSUB 880  
210 PRINT"    ...DISK DRIVE 2: ";:OUT 244,132:GOSUB 880  
220 PRINT"    ...DISK DRIVE 3: ";:OUT 244,136:GOSUB 880  
230 GOSUB 830  
240 PRINT"TEST 4A:  Track Register Checks...Verify no errors":PRINT
250 FOR A = 0 TO 255
260 OUT 241,A:B=INP(241):PRINT@132,"...TRACK ";A
270 IF A<>B PRINT@196,"ERROR TRACK ";A
280 NEXT A
290 PRINT@320,"TEST 4B:  Sector Register Checks...Verify no errors":PRINT
300 FOR A=0 TO 255
310 OUT 242,A:B=INP(242):PRINT@452,"...SECTOR ";A
320 IF A<>B PRINT@516,"ERROR SECTOR ";A
330 NEXT A
340 PRINT@640,"TEST 4C:  Data Register Checks...Verify no errors":PRINT
350 FOR A=0 TO 255
360 OUT 243,A:B=INP(243):PRINT@772,"...DATA = ";A
370 IF A<>B PRINT@836,"ERROR AT DATA VALUE ";A
380 NEXT A
390 GOSUB 830  
400 PRINT"TEST 5:  Track Seeking Checks...Verify Status Bit 4 NOT set":PRINT
410 PRINT"   ...DRIVE 0: ":B=129:GOSUB 470  
420 PRINT"   ...DRIVE 1: ":B=130:GOSUB 470  
430 PRINT"   ...DRIVE 2: ":B=132:GOSUB 470  
440 PRINT"   ...DRIVE 3: ":B=136:GOSUB 470  
450 GOSUB 830  
460 GOTO 10   
470 OUT 240,B
480 OUT 244,3
490 FOR X=1 TO 500
500 OUT 244,B
510 NEXT X
520 OUT 244,B
530 OUT 241,0
540 OUT 243,39
550 OUT 240,23
560 FOR X=1 TO 500
570 OUT 244,B
580 NEXT X
590 OUT 244,B
600 GOSUB 620  
610 RETURN
620 DN=INP(240):ST=DN
630 IF DN-128>=0 THEN DN=DN-128:D7=1 ELSE D7=0
640 IF DN-64>=0 THEN DN=DN-64:D6=1 ELSE D6=0
650 IF DN-32>=0 THEN DN=DN-32:D5=1 ELSE D5=0
660 IF DN-16>=0 THEN DN=DN-16:D4=1 ELSE D4=0
670 IF DN-8>=0 THEN DN=DN-8:D3=1 ELSE D3=0
680 IF DN-4>=0 THEN DN=DN-4:D2=1 ELSE D2=0
690 IF DN-2>=0 THEN DN=DN-2:D1=1 ELSE D1=0
700 IF DN-1>=0 THEN DN=DN-1:D0=1 ELSE D0=0
710 PRINT TAB(32)"S7 S6 S5 S4 S3 S2 S1 S0"
720 PRINT TAB(10)"FDC STATUS REGISTER =";D7;D6;D5;D4;D3;D2;D1;D0;
730 PRINT" = ";ST
740 IF D7=1 THEN PRINT TAB(10)"...Bit 7 set:  Drive motor not up to speed":RETURN
750 IF D6=1 THEN PRINT TAB(10)"...Bit 6 set:  Diskette write protected"
760 IF D5=1 THEN PRINT TAB(10)"...Bit 5 set:  Disk drive door open/No diskette
770 IF D4=1 THEN PRINT TAB(10)"...Bit 4 set:  Seek error - track not verified"
780 IF D3=1 THEN PRINT TAB(10)"...Bit 3 set:  CRC error in ID field"
790 IF D2=1 THEN PRINT TAB(10)"...Bit 2 set:  Disk drive at Track 00"
800 IF D1=1 THEN PRINT TAB(10)"...Bit 1 set:  Index mark detected"
810 IF D0=1 THEN PRINT TAB(10)"...Bit 0 set:  No disk/ette in system"
820 RETURN
830 PRINT
840 PRINT"*** Press any key to continue ***"
850 A$=INKEY$:IF A$="" THEN 850  
860 PRINT:CLS
870 RETURN
880 FOR X=1 TO 500:NEXT X
890 IR=INP(228)
900 IF IR=126 THEN PRINT"Ready flip-flop set":GOTO 930  
910 IF IR=254 THEN PRINT"Interrupt and ready flip-flop set":GOTO 930  
920 PRINT TAB(10)"ERROR:  A problem exists--check further"
930 RETURN
940 OUT 244,B
950 FOR X=1 TO 500
960 OUT 244,B
970 NEXT X
980 OUT 244,B
990 OUT 240,3
1000 FOR X=1 TO 500
1010 OUT 244,B
1020 NEXT X
1030 GOSUB 620  
1040 RETURN
